
#include <Arduino.h>
#define INTERRUPT 2
#define OUT 11 // PB5
#define BUFSIZE 100
#define MAXPERIOD 1000000 // période maximale en microsecondes
			  
uint16_t diviseur[6] = {0,1,8,64,256,1024};
uint8_t clock; // diviseur d'horloge pour Timer 1
uint32_t clock_period; // période d'horloge en microsecondes
uint16_t count[2][BUFSIZE]; // double tampon
uint16_t nBuf,iBuf;
uint8_t flag =0;
bool dataReady;
			  
void timer1_init(uint32_t maxperiod) {  
    TCCR1A = 0;
    TCCR1B = 0;
    TCCR1B |= (1 << WGM12);
    clock = 1;
    uint32_t top = (F_CPU/1000000*maxperiod);
    while ((top>0xFFFF)&&(clock<5)) {
      clock++;
      top = (F_CPU/1000000*maxperiod/diviseur[clock]);
    }
    clock_period = diviseur[clock] / (F_CPU/1000000);
    TCCR1B |= clock;
}
			   
void startTimer() {
  count[nBuf][iBuf]  = TCNT1; // stockage de la valeur du compteur dans le tampon
   TCCR1B = 0; // initialisation du compteur 
   TCCR1B |= clock;
   TCNT1 = 0;
  if (flag) {
      PORTB  &= ~(1<<PORTB5);  // digitalWrite(OUT,LOW)
      flag = 0;
  }
  else {
      PORTB |= (1<<PORTB5);  // digitalWrite(OUT,HIGH)
      flag = 1;
  }
  iBuf++;
  if (iBuf==BUFSIZE) { // fin du tampon
      if (nBuf) nBuf = 0; // changement de tampon
      else nBuf = 1;
      iBuf = 0;
      dataReady = true;
  }
   
}
			   
void setup() {
  Serial.begin(9600);
  attachInterrupt(digitalPinToInterrupt(INTERRUPT), startTimer, RISING);
  pinMode(OUT,OUTPUT);
  digitalWrite(OUT,LOW);
  timer1_init(MAXPERIOD);
  iBuf = nBuf = 0;
  dataReady = false;
}
			   
void loop() {
  if (dataReady) {
    dataReady = false;
    uint8_t n = 0;
    if (nBuf==0) n = 1;
    for (int i=0; i<BUFSIZE; i++) {
      Serial.print(i);
      Serial.print(" : ");
      Serial.println(count[n][i]*clock_period);
    }

  }
}		   
			   